com.fasterxml.jackson.databind.ser

## Class DefaultSerializerProvider

- java.lang.Object
- - com.fasterxml.jackson.databind.DatabindContext
  - - com.fasterxml.jackson.databind.SerializerProvider
    - - com.fasterxml.jackson.databind.ser.DefaultSerializerProvider

All Implemented Interfaces:
  Serializable

Direct Known Subclasses:
  DefaultSerializerProvider.Impl

    public abstract class DefaultSerializerProvider
    extends SerializerProvider
    implements Serializable

Standard implementation used by `ObjectMapper`: adds methods only exposed to `ObjectMapper`, as well as constructors.

Note that class is abstract just because it does not define `createInstance(com.fasterxml.jackson.databind.SerializationConfig, com.fasterxml.jackson.databind.ser.SerializerFactory)` method.

Also note that all custom `SerializerProvider` implementations must sub-class this class: `ObjectMapper` requires this type, not basic provider type.

See Also:
  Serialized Form

### Nested Class Summary

Nested Classes
`static class` `DefaultSerializerProvider.Impl` Concrete implementation that defines factory method(s), defined as final.

### Field Summary

Fields
`protected com.fasterxml.jackson.core.JsonGenerator` `_generator` Generator used for serialization.
`protected ArrayList<ObjectIdGenerator<?>>` `_objectIdGenerators`
`protected Map<Object,WritableObjectId>` `_seenObjectIds` Per-serialization map Object Ids that have seen so far, iff Object Id handling is enabled.

### Fields inherited from class com.fasterxml.jackson.databind.SerializerProvider

`_attributes, _config, _dateFormat, _keySerializer, _knownSerializers, _nullKeySerializer, _nullValueSerializer, _serializationView, _serializerCache, _serializerFactory, _stdNullValueSerializer, _unknownTypeSerializer, CACHE_UNKNOWN_MAPPINGS, DEFAULT_NULL_KEY_SERIALIZER, DEFAULT_UNKNOWN_SERIALIZER`

### Constructor Summary

Constructors
`protected` `DefaultSerializerProvider()`
`protected` `DefaultSerializerProvider(DefaultSerializerProvider src)`
`protected` `DefaultSerializerProvider(SerializerProvider src, SerializationConfig config, SerializerFactory f)`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods Deprecated Methods
`protected Map<Object,WritableObjectId>` `_createObjectIdMap()` Overridable helper method used for creating `Map` used for storing mappings from serializable objects to their Object Ids.
`protected void` `_serializeNull(com.fasterxml.jackson.core.JsonGenerator gen)` Helper method called when root value to serialize is null
`void` `acceptJsonFormatVisitor(JavaType javaType, JsonFormatVisitorWrapper visitor)` The method to be called by `ObjectMapper` and `ObjectWriter` to to expose the format of the given to to the given visitor
`int` `cachedSerializersCount()` Method that can be used to determine how many serializers this provider is caching currently (if it does caching: default implementation does) Exact count depends on what kind of serializers get cached; default implementation caches all serializers, including ones that are eagerly constructed (for optimal access speed)
`DefaultSerializerProvider` `copy()` Method needed to ensure that `ObjectMapper.copy()` will work properly; specifically, that caches are cleared, but settings will otherwise remain identical; and that no sharing of state occurs.
`abstract DefaultSerializerProvider` `createInstance(SerializationConfig config, SerializerFactory jsf)` Method that sub-classes need to implement: used to create a non-blueprint instances from the blueprint.
`WritableObjectId` `findObjectId(Object forPojo, ObjectIdGenerator<?> generatorType)` Method called to find the Object Id for given POJO, if one has been generated.
`void` `flushCachedSerializers()` Method that will drop all serializers currently cached by this provider.
`JsonSchema` `generateJsonSchema(Class<?> type)` Deprecated. Should not be used any more
`com.fasterxml.jackson.core.JsonGenerator` `getGenerator()` Accessor for the `JsonGenerator` currently in use for serializing content.
`boolean` `hasSerializerFor(Class<?> cls, AtomicReference<Throwable> cause)` Method that can be called to see if this serializer provider can find a serializer for an instance of given class.
`Object` `includeFilterInstance(BeanPropertyDefinition forProperty, Class<?> filterClass)` Method that can be called to construct and configure `JsonInclude` filter instance, given a `Class` to instantiate (with default constructor, by default).
`boolean` `includeFilterSuppressNulls(Object filter)` Follow-up method that may be called after calling `SerializerProvider.includeFilterInstance(com.fasterxml.jackson.databind.introspect.BeanPropertyDefinition, java.lang.Class<?>)`, to check handling of `null` values by the filter.
`void` `serializePolymorphic(com.fasterxml.jackson.core.JsonGenerator gen, Object value, JavaType rootType, JsonSerializer<Object> valueSer, TypeSerializer typeSer)` Alternate serialization call used for polymorphic types, when `TypeSerializer` is already known, but the actual serializer may or may not be.
`JsonSerializer<Object>` `serializerInstance(Annotated annotated, Object serDef)` Method that can be called to construct and configure serializer instance, either given a `Class` to instantiate (with default constructor), or an uninitialized serializer instance.
`void` `serializeValue(com.fasterxml.jackson.core.JsonGenerator gen, Object value)` The method to be called by `ObjectMapper` and `ObjectWriter` for serializing given value, using serializers that this provider has access to (via caching and/or creating new serializers as need be).
`void` `serializeValue(com.fasterxml.jackson.core.JsonGenerator gen, Object value, JavaType rootType)` The method to be called by `ObjectMapper` and `ObjectWriter` for serializing given value (assumed to be of specified root type, instead of runtime type of value), using serializers that this provider has access to (via caching and/or creating new serializers as need be),
`void` `serializeValue(com.fasterxml.jackson.core.JsonGenerator gen, Object value, JavaType rootType, JsonSerializer<Object> ser)` The method to be called by `ObjectWriter` for serializing given value (assumed to be of specified root type, instead of runtime type of value), when it may know specific `JsonSerializer` to use.

### Methods inherited from class com.fasterxml.jackson.databind.SerializerProvider

`_createAndCacheUntypedSerializer, _createAndCacheUntypedSerializer, _createUntypedSerializer, _dateFormat, _findExplicitUntypedSerializer, _handleContextualResolvable, _handleResolvable, _reportIncompatibleRootType, bufferForValueConversion, bufferForValueConversion, canOverrideAccessModifiers, constructSpecializedType, defaultSerializeDateKey, defaultSerializeDateKey, defaultSerializeDateValue, defaultSerializeDateValue, defaultSerializeField, defaultSerializeNull, defaultSerializeValue, findContentValueSerializer, findContentValueSerializer, findKeySerializer, findKeySerializer, findNullKeySerializer, findNullValueSerializer, findPrimaryPropertySerializer, findPrimaryPropertySerializer, findTypedValueSerializer, findTypedValueSerializer, findTypeSerializer, findValueSerializer, findValueSerializer, findValueSerializer, findValueSerializer, getActiveView, getAnnotationIntrospector, getAttribute, getConfig, getDefaultNullKeySerializer, getDefaultNullValueSerializer, getDefaultPropertyFormat, getDefaultPropertyInclusion, getFilterProvider, getLocale, getTimeZone, getTypeFactory, getUnknownTypeSerializer, handlePrimaryContextualization, handleSecondaryContextualization, hasSerializationFeatures, invalidTypeIdException, isEnabled, isEnabled, isEnabled, isUnknownTypeSerializer, mappingException, mappingException, reportBadDefinition, reportBadDefinition, reportBadDefinition, reportBadPropertyDefinition, reportBadTypeDefinition, reportMappingProblem, reportMappingProblem, setAttribute, setDefaultKeySerializer, setNullKeySerializer, setNullValueSerializer`

### Methods inherited from class com.fasterxml.jackson.databind.DatabindContext

`_colonConcat, _desc, _format, _quotedString, _throwNotASubtype, _throwSubtypeClassNotAllowed, _throwSubtypeNameNotAllowed, _truncate, constructType, converterInstance, objectIdGeneratorInstance, objectIdResolverInstance, reportBadDefinition, resolveAndValidateSubType, resolveSubType`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _seenObjectIds

    protected transient Map<Object,WritableObjectId> _seenObjectIds

Per-serialization map Object Ids that have seen so far, iff Object Id handling is enabled.

#### _objectIdGenerators

    protected transient ArrayList<ObjectIdGenerator<?>> _objectIdGenerators

#### _generator

    protected transient com.fasterxml.jackson.core.JsonGenerator _generator

Generator used for serialization. Needed mostly for error reporting purposes.

Since:
  2.8

### Constructor Detail

#### DefaultSerializerProvider

    protected DefaultSerializerProvider()

#### DefaultSerializerProvider

    protected DefaultSerializerProvider(SerializerProvider src,
                                        SerializationConfig config,
                                        SerializerFactory f)

#### DefaultSerializerProvider

    protected DefaultSerializerProvider(DefaultSerializerProvider src)

### Method Detail

#### createInstance

    public abstract DefaultSerializerProvider createInstance(SerializationConfig config,
                                                             SerializerFactory jsf)

Method that sub-classes need to implement: used to create a non-blueprint instances from the blueprint. This is needed to retain state during serialization.

#### copy

    public DefaultSerializerProvider copy()

Method needed to ensure that `ObjectMapper.copy()` will work properly; specifically, that caches are cleared, but settings will otherwise remain identical; and that no sharing of state occurs.

Since:
  2.5

#### serializerInstance

    public JsonSerializer<Object> serializerInstance(Annotated annotated,
                                                     Object serDef)
                                              throws JsonMappingException

Description copied from class: `SerializerProvider`
Method that can be called to construct and configure serializer instance, either given a `Class` to instantiate (with default constructor), or an uninitialized serializer instance. Either way, serialize will be properly resolved (via `ResolvableSerializer`) and/or contextualized (via `ContextualSerializer`) as necessary.

Specified by:
  `serializerInstance` in class `SerializerProvider`
Parameters:
  `annotated` - Annotated entity that contained definition
  `serDef` - Serializer definition: either an instance or class
Throws:
  `JsonMappingException`

#### includeFilterInstance

    public Object includeFilterInstance(BeanPropertyDefinition forProperty,
                                        Class<?> filterClass)

Description copied from class: `SerializerProvider`
Method that can be called to construct and configure `JsonInclude` filter instance, given a `Class` to instantiate (with default constructor, by default).

Specified by:
  `includeFilterInstance` in class `SerializerProvider`
Parameters:
  `forProperty` - (optional) If filter is created for a property, that property; `null` if filter created via defaulting, global or per-type.

#### includeFilterSuppressNulls

    public boolean includeFilterSuppressNulls(Object filter)
                                       throws JsonMappingException

Description copied from class: `SerializerProvider`
Follow-up method that may be called after calling `SerializerProvider.includeFilterInstance(com.fasterxml.jackson.databind.introspect.BeanPropertyDefinition, java.lang.Class<?>)`, to check handling of `null` values by the filter.

Specified by:
  `includeFilterSuppressNulls` in class `SerializerProvider`
Throws:
  `JsonMappingException`

#### findObjectId

    public WritableObjectId findObjectId(Object forPojo,
                                         ObjectIdGenerator<?> generatorType)

Description copied from class: `SerializerProvider`
Method called to find the Object Id for given POJO, if one has been generated. Will always return a non-null Object; contents vary depending on whether an Object Id already exists or not.

Specified by:
  `findObjectId` in class `SerializerProvider`

#### _createObjectIdMap

    protected Map<Object,WritableObjectId> _createObjectIdMap()

Overridable helper method used for creating `Map` used for storing mappings from serializable objects to their Object Ids.

Since:
  2.3

#### hasSerializerFor

    public boolean hasSerializerFor(Class<?> cls,
                                    AtomicReference<Throwable> cause)

Method that can be called to see if this serializer provider can find a serializer for an instance of given class.

Note that no Exceptions are thrown, including unchecked ones: implementations are to swallow exceptions if necessary.

#### getGenerator

    public com.fasterxml.jackson.core.JsonGenerator getGenerator()

Accessor for the `JsonGenerator` currently in use for serializing content. Null for blueprint instances; non-null for actual active provider instances.

Overrides:
  `getGenerator` in class `SerializerProvider`
Since:
  2.8

#### serializeValue

    public void serializeValue(com.fasterxml.jackson.core.JsonGenerator gen,
                               Object value)
                        throws IOException

The method to be called by `ObjectMapper` and `ObjectWriter` for serializing given value, using serializers that this provider has access to (via caching and/or creating new serializers as need be).

Throws:
  `IOException`

#### serializeValue

    public void serializeValue(com.fasterxml.jackson.core.JsonGenerator gen,
                               Object value,
                               JavaType rootType)
                        throws IOException

The method to be called by `ObjectMapper` and `ObjectWriter` for serializing given value (assumed to be of specified root type, instead of runtime type of value), using serializers that this provider has access to (via caching and/or creating new serializers as need be),

Parameters:
  `rootType` - Type to use for locating serializer to use, instead of actual runtime type. Must be actual type, or one of its super types
Throws:
  `IOException`

#### serializeValue

    public void serializeValue(com.fasterxml.jackson.core.JsonGenerator gen,
                               Object value,
                               JavaType rootType,
                               JsonSerializer<Object> ser)
                        throws IOException

The method to be called by `ObjectWriter` for serializing given value (assumed to be of specified root type, instead of runtime type of value), when it may know specific `JsonSerializer` to use.

Parameters:
  `rootType` - Type to use for locating serializer to use, instead of actual runtime type, if no serializer is passed
  `ser` - Root Serializer to use, if not null
Throws:
  `IOException`
Since:
  2.1

#### serializePolymorphic

    public void serializePolymorphic(com.fasterxml.jackson.core.JsonGenerator gen,
                                     Object value,
                                     JavaType rootType,
                                     JsonSerializer<Object> valueSer,
                                     TypeSerializer typeSer)
                              throws IOException

Alternate serialization call used for polymorphic types, when `TypeSerializer` is already known, but the actual serializer may or may not be.

Throws:
  `IOException`
Since:
  2.6

#### _serializeNull

    protected void _serializeNull(com.fasterxml.jackson.core.JsonGenerator gen)
                           throws IOException

Helper method called when root value to serialize is null

Throws:
  `IOException`
Since:
  2.3

#### cachedSerializersCount

    public int cachedSerializersCount()

Method that can be used to determine how many serializers this provider is caching currently (if it does caching: default implementation does) Exact count depends on what kind of serializers get cached; default implementation caches all serializers, including ones that are eagerly constructed (for optimal access speed)

The main use case for this method is to allow conditional flushing of serializer cache, if certain number of entries is reached.

#### flushCachedSerializers

    public void flushCachedSerializers()

Method that will drop all serializers currently cached by this provider. This can be used to remove memory usage (in case some serializers are only used once or so), or to force re-construction of serializers after configuration changes for mapper than owns the provider.

#### acceptJsonFormatVisitor

    public void acceptJsonFormatVisitor(JavaType javaType,
                                        JsonFormatVisitorWrapper visitor)
                                 throws JsonMappingException

The method to be called by `ObjectMapper` and `ObjectWriter` to to expose the format of the given to to the given visitor

Parameters:
  `javaType` - The type for which to generate format
  `visitor` - the visitor to accept the format
Throws:
  `JsonMappingException`

#### generateJsonSchema

    @Deprecated
    public JsonSchema generateJsonSchema(Class<?> type)
                                              throws JsonMappingException

Deprecated. Should not be used any more
The method to be called by `ObjectMapper` to generate JSON schema for given type.

Parameters:
  `type` - The type for which to generate schema
Throws:
  `JsonMappingException`